
/********************************** (C) COPYRIGHT *********************************
* File Name          : Moduleconfig.H
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395.Cݽṹ
*                      
**********************************************************************************/
//  NetModuleProtol.h: CH395ģͨŵĻݽṹýṹ

#ifndef __MODULECONFIG_H__
#define __MODULECONFIG_H__

#define NET_MODULE_DATA_LENGTH    60     //ģͨʱ󳤶

#define MODULE_CFG_LEN            42

//ͨ
#define NET_MODULE_CMD_SET      0X01     //еģ
#define NET_MODULE_CMD_GET      0X02     //ȡĳģ
#define NET_MODULE_CMD_RESET    0X03   //ȡĳģ
#define NET_MODULE_CMD_SEARCH   0X04    //еģ

//Ӧ
#define NET_MODULE_ACK_SET      0X81     //Ӧ
#define NET_MODULE_ACK_GET      0X82     //Ӧȡ
#define NET_MODULE_ACK_RESET    0X83     //ȡĳģ
#define NET_MODULE_ACK_SEARCH   0X84     //Ӧ

#define NET_MODULE_FLAG        "CH395NET_MODULE"    //ʶͨ

#define SynCode1          0x55
#define SynCode2          0xaa
//Ĭ

//ͨŽṹ
typedef struct NET_COMM {
  unsigned char flag[16];                       //ͨűʶΪù㲥ʽͨŵģһ̶ֵ
  unsigned char cmd;                            //ͷ
  unsigned char id[6];                          //ʶCH395MACַ
  unsigned char len;                            //
  unsigned char dat[NET_MODULE_DATA_LENGTH];    //
}net_comm,*pnet_comm;

//ģʶ
#define  NET_MODULE_TYPE_TCP_S    0X00    //ģΪTCP SERVER
#define  NET_MODULE_TYPE_TCP_C    0X01    //ģΪTCP CLIENT
#define  NET_MODULE_TYPE_UDP_S    0X02    //ģΪUDP SERVER
#define NET_MODULE_TYPE_UDP_C     0X03    //ģΪUDP CLIENT 



//ģýṹ
typedef struct MODULE_CFG {
  unsigned char module_name[21];             //ģ鱾IPַ    
  unsigned char type;                        //ʶģ鴦ģʽ(TCP/UDP server/client)
  unsigned char src_ip[4];                   //ģ鱾IPַ
  unsigned char mask[4];                     //ģ鱾
  unsigned char getway[4];                   //ģӦصַ
  unsigned char src_port[2];                 //ģԴ˿
  unsigned char dest_ip[4];                  //ĿIPַ
  unsigned char dest_port[2];                //ĿĶ˿
}module_cfg,*pmodule_cfg;

//Ĭ
extern UINT8 DefaultSrcIp[4] ;
extern UINT8 DefaultMask[4]  ;
extern UINT8 DefaultGetway[4] ;
extern UINT16 DefaultSrcPort;
extern UINT8  ParseConfigbuf(PUINT8 buf);  
extern UINT8 DefaultDesIp[4];
extern UINT16 DefaultDesPort;
extern UINT8   MODULE_NAME[21];

#endif
